// $Id: CompactScanner.h,v 1.6 2007/03/17 19:19:27 david Exp $ -*- c++ -*-
/*
 * $Log: CompactScanner.h,v $
 * Revision 1.6  2007/03/17 19:19:27  david
 * *** empty log message ***
 *
 */
#ifndef __COMPACTSCANNER_H__
#define __COMPACTSCANNER_H__

#include <iostream>
#include <FlexLexer.h>

// Needed because in some versions "cerr" appears naked!
using namespace std;

//!
//! This class declaration corresponds to the class implementation generated
//! by the <tt>flex</tt> program for the <tt>yylex</tt> member function which
//! contains the lexical analyser rules defined in file CompactScanner.l.
//! Note that the class name must be as defined in the lexical analyser file.
//!
class CompactScanner : public yyFlexLexer {
  const char *_filename;

public:  // constructors
  //!
  //! Constructor: the constructor does the same as the superclass'.
  //!
  //! @param filename input filename
  //! @param yyin is the input stream
  //! @param yyout is the output stream
  //!
  CompactScanner(const char *filename, std::istream *yyin = NULL, std::ostream *yyout = NULL)
    : yyFlexLexer(yyin, yyout), _filename(filename) {
      //set_debug(1);
  }

public:  // methods
  //!
  //! This function will be automatically generated by <tt>flex</tt>
  //! from the lexical rules defined in file CompactScanner.l.
  //! 
  //! @return the recognised token
  //!
  int yylex();

public:
  void yyerror(char *s) {
    std::cerr << _filename << ": line " << lineno() << ": " << s << std::endl;
  }

  // ele há dias assim... <suspiro/>
  void yyerror(const char *const s) { yyerror((char*)s); }

};

#endif
