// $Id: CompilerImpl.h,v 1.3 2007/03/17 19:19:28 david Exp $ -*- c++ -*-
/*
 * $Log: CompilerImpl.h,v $
 * Revision 1.3  2007/03/17 19:19:28  david
 * *** empty log message ***
 *
 */
#ifndef __COMPACTCOMPILERIMPL_H__
#define __COMPACTCOMPILERIMPL_H__

#include <iostream>
#include <cdk/Compiler.h>

class FlexLexer;

/**
 * This class corresponds to the compiler as a whole. It is an
 * implementation of the abstract class Compiler (defined by the CDK).
 * It includes the definitions for the scanner (_scanner), inherited from the
 * superclass; the parser (yyparser -- pure virtual in the superclass) generated
 * by 'byacc'; and the evaluator (programmer-written and provided by this class).
 * @see cdk::Compiler
 */
class CompilerImpl : public cdk::Compiler {

public:  // constructors

  /**
   * Constructor: the constructor does the same as the superclass'
   * @param name compiler name
   * @param scanner the lexical analyser
   */
  CompilerImpl(const char *name, FlexLexer *scanner) : cdk::Compiler(name, scanner) {}

public:  // methods

  /**
   * This is the main parsing function.
   * It is automatically generated by 'byacc'
   */
  int yyparse();

};

#endif
