// $Id: AssignmentNode.h,v 1.4 2008/03/01 18:32:50 david Exp $ -*- c++ -*-
/*
 * $Log: AssignmentNode.h,v $
 * Revision 1.4  2008/03/01 18:32:50  david
 * Compact for CDK3 (first version).
 *
 * Revision 1.3  2007/03/17 19:19:32  david
 * *** empty log message ***
 *
 * Revision 1.2  2007/03/13 00:26:27  david
 * This version of the Compact compiler uses the new CDK2 library.
 * All nodes and visitors now use non-overloaded visitor hooks. The Compact
 * compiler now implements the abstract factory for scanners and compilers.
 * A separate evaluator is no longer needed since the compiler implementation
 * (CompilerImpl) now provides a better encapsulation.
 *
 * Revision 1.1.1.1  2006/01/03 16:37:23  david
 */
#ifndef __COMPACT_ASSIGNMENTNODE_H__
#define __COMPACT_ASSIGNMENTNODE_H__

#include <cdk/nodes/Node.h>
#include <cdk/nodes/expressions/Expression.h>

//!
//! Class for describing assignment nodes.
//!
class AssignmentNode : public cdk::node::Node {
  cdk::node::expression::Expression *_lvalue, *_rvalue;
  
public:
  inline AssignmentNode(int lineno, cdk::node::expression::Expression *lvalue, cdk::node::expression::Expression *rvalue)
    : cdk::node::Node(lineno), _lvalue(lvalue), _rvalue(rvalue) {}
  
public:
  inline cdk::node::expression::Expression *lvalue()  { return _lvalue;  }
  inline cdk::node::expression::Expression *rvalue()  { return _rvalue;  }

public:
  const char *name() { return "AssignmentNode"; }

  void accept(SemanticProcessor *sp, int level) {
    sp->processAssignmentNode(this, level);
  }

};

#endif
