// $Id: IfElseNode.h,v 1.4 2008/03/01 18:32:50 david Exp $ -*- c++ -*-
/*
 * $Log: IfElseNode.h,v $
 * Revision 1.4  2008/03/01 18:32:50  david
 * Compact for CDK3 (first version).
 *
 * Revision 1.3  2007/03/17 19:19:33  david
 * *** empty log message ***
 *
 * Revision 1.2  2007/03/13 00:26:27  david
 * This version of the Compact compiler uses the new CDK2 library.
 * All nodes and visitors now use non-overloaded visitor hooks. The Compact
 * compiler now implements the abstract factory for scanners and compilers.
 * A separate evaluator is no longer needed since the compiler implementation
 * (CompilerImpl) now provides a better encapsulation.
 *
 * Revision 1.1.1.1  2006/01/03 16:37:23  david
 */
#ifndef __COMPACT_IFELSENODE_H__
#define __COMPACT_IFELSENODE_H__

#include <cdk/nodes/Node.h>
#include <cdk/nodes/expressions/Expression.h>

//!
//! Class for describing if-then-else nodes.
//!
class IfElseNode : public cdk::node::Node {
  cdk::node::expression::Expression *_condition;
  cdk::node::Node *_thenblock, *_elseblock;
  
public:
  inline IfElseNode(int lineno, cdk::node::expression::Expression *condition,
		    cdk::node::Node *thenblock, cdk::node::Node *elseblock)
    : cdk::node::Node(lineno), _condition(condition),
      _thenblock(thenblock), _elseblock(elseblock) {}
  
public:
  inline cdk::node::expression::Expression *condition() { return _condition; }
  inline cdk::node::Node                   *thenblock() { return _thenblock; }
  inline cdk::node::Node                   *elseblock() { return _elseblock; }
  
public:
  const char *name() { return "IfElseNode"; }

  void accept(SemanticProcessor *sp, int level) {
    sp->processIfElseNode(this, level);
  }

};

#endif
