// $Id: PrintNode.h,v 1.3 2008/03/01 18:32:50 david Exp $ -*- c++ -*-
/*
 * $Log: PrintNode.h,v $
 * Revision 1.3  2008/03/01 18:32:50  david
 * Compact for CDK3 (first version).
 *
 * Revision 1.2  2007/03/13 00:26:28  david
 * This version of the Compact compiler uses the new CDK2 library.
 * All nodes and visitors now use non-overloaded visitor hooks. The Compact
 * compiler now implements the abstract factory for scanners and compilers.
 * A separate evaluator is no longer needed since the compiler implementation
 * (CompilerImpl) now provides a better encapsulation.
 *
 * Revision 1.1.1.1  2006/01/03 16:37:23  david
 */
#ifndef __COMPACT_PRINTNODE_H__
#define __COMPACT_PRINTNODE_H__

#include <cdk/nodes/Node.h>
#include <cdk/nodes/expressions/Expression.h>

//!
//! Class for describing print nodes.
//!
class PrintNode : public cdk::node::Node {
  cdk::node::expression::Expression *_argument;
  
public:
  inline PrintNode(int lineno, cdk::node::expression::Expression *argument)
    : cdk::node::Node(lineno), _argument(argument) {}
  
public:
  inline cdk::node::expression::Expression *argument() { return _argument;  }

public:
  const char *name() { return "PrintNode"; }

  void accept(SemanticProcessor *sp, int level) {
    sp->processPrintNode(this, level);
  }

};

#endif
