// $Id: ProgramNode.h,v 1.3 2008/03/01 18:32:50 david Exp $ -*- c++ -*-
/*
 * $Log: ProgramNode.h,v $
 * Revision 1.3  2008/03/01 18:32:50  david
 * Compact for CDK3 (first version).
 *
 * Revision 1.2  2007/03/13 00:26:28  david
 * This version of the Compact compiler uses the new CDK2 library.
 * All nodes and visitors now use non-overloaded visitor hooks. The Compact
 * compiler now implements the abstract factory for scanners and compilers.
 * A separate evaluator is no longer needed since the compiler implementation
 * (CompilerImpl) now provides a better encapsulation.
 *
 * Revision 1.1.1.1  2006/01/03 16:37:23  david
 */
#ifndef __COMPACT_PROGRAMNODE_H__
#define __COMPACT_PROGRAMNODE_H__

#include <cdk/nodes/Node.h>

//!
//! Class for describing program nodes.
//!
class ProgramNode : public cdk::node::Node {
  cdk::node::Node *_statements;

public:
  inline ProgramNode(int lineno, cdk::node::Node *statements)
    : cdk::node::Node(lineno), _statements(statements) {}

public:
  inline cdk::node::Node *statements() { return _statements;  }

public:
  const char *name() const { return "ProgramNode"; }

  void accept(SemanticProcessor *sp, int level) {
    sp->processProgramNode(this, level);
  }


};

#endif
