// $Id: WhileNode.h,v 1.3 2008/03/01 18:32:50 david Exp $ -*- c++ -*-
/*
 * $Log: WhileNode.h,v $
 * Revision 1.3  2008/03/01 18:32:50  david
 * Compact for CDK3 (first version).
 *
 * Revision 1.2  2007/03/13 00:26:29  david
 * This version of the Compact compiler uses the new CDK2 library.
 * All nodes and visitors now use non-overloaded visitor hooks. The Compact
 * compiler now implements the abstract factory for scanners and compilers.
 * A separate evaluator is no longer needed since the compiler implementation
 * (CompilerImpl) now provides a better encapsulation.
 *
 * Revision 1.1.1.1  2006/01/03 16:37:23  david
 */
#ifndef __COMPACT_WHILENODE_H__
#define __COMPACT_WHILENODE_H__

#include <cdk/nodes/Node.h>
#include <cdk/nodes/expressions/Expression.h>

//!
//! Class for describing while-cycle nodes.
//!
class WhileNode : public cdk::node::Node {
  cdk::node::expression::Expression *_condition;
  cdk::node::Node *_block;
  
public:
  inline WhileNode(int lineno, cdk::node::expression::Expression *condition, cdk::node::Node *block)
    : cdk::node::Node(lineno), _condition(condition), _block(block) {}
  
public:
  inline cdk::node::expression::Expression *condition() { return _condition; }
  inline cdk::node::Node                   *block()     { return _block;     }

public:
  const char *name() { return "WhileNode"; }

  void accept(SemanticProcessor *sp, int level) {
    sp->processWhileNode(this, level);
  }

};

#endif
