// $Id: Cevaluator.cpp,v 1.2 2007/03/17 19:19:35 david Exp $
/*
 * $Log: Cevaluator.cpp,v $
 * Revision 1.2  2007/03/17 19:19:35  david
 * *** empty log message ***
 *
 * Revision 1.1  2007/03/14 01:20:26  david
 * Changed compiler implementation to use evaluation strategy objects
 * instead of functions. These strategies are selected according to the
 * target selected from the command line options or from clues such as
 * the output file extension.
 */

//---------------------------------------------------------------------------

#include <cdk/nodes/Node.h>
#include <cdk/SymbolTable.h>
#include <cdk/Compiler.h>
#include "semantics/Cevaluator.h"
#include "semantics/Cwriter.h"

//---------------------------------------------------------------------------

/**
 * @var create and register an evaluator for C targets.
 */
Cevaluator Cevaluator::_thisEvaluator("c");

//---------------------------------------------------------------------------

bool Cevaluator::evaluate(cdk::Compiler *compiler) {
  // this symbol table will be used to check identifiers
  cdk::SymbolTable symtab;
  std::ostream &os = compiler->ostream();

  // we must open the outer function
  // the output stream must be the same used for the two processors
  //
  os << "#include <stdio.h>\n";
  os << "int main() {\n";

  // the C code will be generated
  // an exception will be thrown if identifiers are used before declaration
  //
  Cwriter cwriter(os, symtab);
  compiler->syntax()->accept(&cwriter, 0);

  // we must close the outer function
  // the output stream must be the same used for the two processors
  //
  os << "  return 0;\n}\n";

  return true;
}

//---------------------------------------------------------------------------
//     T H E    E N D
//---------------------------------------------------------------------------
