// $Id: InterpretationEvaluator.cpp,v 1.1 2007/03/14 01:20:27 david Exp $
/*
 * $Log: InterpretationEvaluator.cpp,v $
 * Revision 1.1  2007/03/14 01:20:27  david
 * Changed compiler implementation to use evaluation strategy objects
 * instead of functions. These strategies are selected according to the
 * target selected from the command line options or from clues such as
 * the output file extension.
 *
 */

//---------------------------------------------------------------------------

#include <cdk/nodes/Node.h>
#include <cdk/SymbolTable.h>
#include <cdk/Compiler.h>
#include "semantics/InterpretationEvaluator.h"
#include "semantics/Interpreter.h"

//---------------------------------------------------------------------------

/**
 * @var create and register an evaluator for interpretation targets.
 */
InterpretationEvaluator InterpretationEvaluator::_thisEvaluator("...");

//---------------------------------------------------------------------------

bool InterpretationEvaluator::evaluate(cdk::Compiler *compiler) {
  // the interpreter always uses the standard output
  std::ostream &os = std::cout;

  // this symbol table will be used to check identifiers
  cdk::SymbolTable symtab;

  // the interpreter will use the syntactic tree to directly run the program
  // an exception will be thrown if identifiers are used before declaration
  //
  Interpreter interpreter(os, symtab);
  compiler->syntax()->accept(&interpreter, 0);

  return true;
}

//---------------------------------------------------------------------------
//     T H E    E N D
//---------------------------------------------------------------------------
