// $Id: XMLevaluator.cpp,v 1.2 2007/03/17 19:19:38 david Exp $
/*
 * $Log: XMLevaluator.cpp,v $
 * Revision 1.2  2007/03/17 19:19:38  david
 * *** empty log message ***
 *
 * Revision 1.1  2007/03/14 01:20:29  david
 * Changed compiler implementation to use evaluation strategy objects
 * instead of functions. These strategies are selected according to the
 * target selected from the command line options or from clues such as
 * the output file extension.
 */

//---------------------------------------------------------------------------

#include <cdk/nodes/Node.h>
#include <cdk/SymbolTable.h>
#include <cdk/Compiler.h>
#include "semantics/XMLevaluator.h"
#include "semantics/XMLwriter.h"

//---------------------------------------------------------------------------

/**
 * @var create and register an evaluator for XML targets.
 */
XMLevaluator XMLevaluator::_thisEvaluator("xml");

//---------------------------------------------------------------------------

bool XMLevaluator::evaluate(cdk::Compiler *compiler) {
  XMLwriter sp(compiler->ostream());
  compiler->syntax()->accept(&sp, 0);
  return true;
}

//---------------------------------------------------------------------------
//     T H E    E N D
//---------------------------------------------------------------------------
